Subject: Re: [HACKERS] Help: fmgr_info: function 0: cache lookup failed

From: Bruce Momjian <[email-masked]>
Date: Wed, 7 Jul 1999 17:32:45 -0400 (EDT)

Tom, was this dealth with?

> "D'Arcy" "J.M." Cain <[email-masked]> writes:
> >>>> I tried just setting oprcanhash to true but that didn't do it.  Can
> >>>> you suggest what fields I need to look at in pg_operator?
> >> 
> >> oprrest and oprjoin
> 
> > OK, I did this and it worked.  I'll go work on the documentation now.
> 
> OK, I see the problem: btreesel() and friends blithely assume that the
> operator used in an index will have a selectivity function (oprrest).
> 
> I can see two reasonable fixes:
>   * Default to an 0.5 estimate if no oprrest link (this is what the
>     optimizer does for operators that have no oprrest).
>   * Generate an error message along the lines of "index operators must
>     have a restriction selectivity estimator", if we think that they
>     really really oughta.
> 
> I'm not sure which way to jump.  The former would be more friendly for
> people just starting to develop index support for a new data type ...
> but then they might never realize that lack of an estimator is hurting
> performance for them.  Comments?
> 
> 			regards, tom lane
> 
> 

-- 
  Bruce Momjian                        |  http://www.op.net/~candle
  [email-masked]            |  (610) 853-3000
  +  If your life is a hard drive,     |  830 Blythe Avenue
  +  Christ can be your backup.        |  Drexel Hill, Pennsylvania 19026

---

From: Tom Lane <[email-masked]>
Date: Wed, 07 Jul 1999 18:06:13 -0400

> Tom, was this dealth with?

What I originally did was the second choice (generate an error message)
but I had to back off to using a default when we discovered that the
rtree index operators don't have oprrest links in 6.5 :-(.  I would
like to change it back after the rtree index entries are fixed, but
for the meanwhile you can mark this item done.

			regards, tom lane